<?php
/**
 * ----------------------------------------------------------
 * Copyright (c) 2005  KLIK! Klein Informatik  
 *                     www.klik-info.ch rklein@klik-info.ch
 * ----------------------------------------------------------
 *
 * KLIK! Mini-Shop
 *
 * Dieses Skript darf nicht in Projekten verwendet werden, die
 * faschistisches, rassistisches, sexistisches oder 
 * fanatisch-religioeses Gedankengut propagieren.
 *
 * @author      Roger Klein
 * @copyright   Frei einsetzbar, solange obige Vorgabe erfuellt ist
 *              und alle (c) Kommentar-Zeilen im Code bleiben
 * @version     1.0 | 2005-10-12
 */
 
if (isset($_GET['logout']))
{
    session_start();
    session_destroy();
}

require_once '../inc/db_login.php';
require_once 'login.php';
require_once '../inc/aufklapp_oop.php';
require_once '../inc/form_fus.php';

$meldung = '';
$k_id = isset($_REQUEST['k_id']) ? $_REQUEST['k_id'] : -1;
$data = array('kat'        => '',
              'aktiv'      => '',
              'sortierung' => ''
             );

// Kategorie loeschen; referenzielle Integritaet beachten -
// sprich: Nur Kategorien ohne zugewiesene Artikel lassen
// sich loeschen
if (isset($_GET['action']) && $_GET['action'] == 'delete')
{
    // Gibt es Artikel, die der zu loeschenden
    // Kategorie zugewiesen sind?
    $abfrage = 'SELECT a_id as anzahl
                FROM '.$tbl_prefix.'artikel
                WHERE k_id = "' . $_GET['k_id'] . '"';
    $ergebnis = mysql_query($abfrage);
    // Falls es keine Artikel gibt => Loeschen
    // der Kategorie
    if (mysql_num_rows($ergebnis) == 0)
    {
        if (mysql_query('DELETE FROM ' . $tbl_prefix . 'kategorien
                         WHERE k_id =' . $_GET['k_id']))
        {
            $meldung = '<span class="green">Die Kategorie wurde gel&ouml;scht</span>';
        }
    }
    else
    {
        $meldung = '<span class="red">Die Kategorie kann nicht gel&ouml;scht werden.</span>';
    }
}

// Formulardaten verarbeiten:
// Aenderungen / Neueintrag speichern
if (isset($_POST['k_id']))
{
    // Formular-Daten filtern
    $data = array_map('filter_data', $_POST);
    $data['kat'] = $data['kat'] == '' ? '---' : $data['kat'];
    // Neueintrag
    if ($k_id == -1)
    {
        // Formular-Daten "quoten"
        $abfrage = 'INSERT INTO ' . $tbl_prefix . 'kategorien
                    (kat,aktiv,sortierung)
                    VALUES (' 
                    . sql_quote($data['kat']) . ',' 
                    . sql_quote($data['aktiv']) . ',' 
                    . sql_quote($data['sortierung']).')';
        if (FALSE != mysql_query($abfrage))
        {
            $meldung  = '<span class="green">Der Neueintrag wurde erfasst</span>';
        }
    }
    // bestehenden Eintrag aktualisieren
    else
    {
        $abfrage = 'UPDATE ' . $tbl_prefix . 'kategorien SET
                    kat = ' . sql_quote($data['kat']) . ',
                    aktiv = ' . sql_quote($data['aktiv']) . ',
                    sortierung = ' . sql_quote($data['sortierung']) . '
                    WHERE k_id = "' . $k_id . '"';
        if (FALSE != mysql_query($abfrage))
        {
            $meldung = '<font color="green">Die &Auml;nderungen wurden gespeichert</font>';
        }
    }
}
?>
<html>
    <head>
        <meta http-equiv="content-type" content="text/html;charset=ISO-8859-1">
        <meta name="robot" content="noindex, nofollow">
        <title>KLIK! Mini-Shop - Administration</title>
        <link rel="StyleSheet" href="../korb.css" type="text/css">
    </head>

<body>
<?php
// Falls der Kategorie-Name (=> Bearbeiten)
// bzw. das [+] (=> Neueintrag) angeklickt wurden,
// ist die Variable $_GET['action'] gesetzt =>
// Es wird ein <form> ... </form>-Konstrukt um 
// die ganze Tabelle gelegt ("Inline-Formular")
if (isset($_GET['action']))
{
    echo '<form name="editform" action="'.$_SERVER['PHP_SELF'].'" method="post">';
}
?>
<div id="titel">
<h3>KLIK! Mini-Shop Administration</h3>
</div>
<div id="aufklapp">
<?php echo $meldung; ?>
</div>
<?php
// Kategorien auflisten
$abfrage = 'SELECT k_id, kat, aktiv, sortierung
            FROM ' . $tbl_prefix . 'kategorien
            ORDER BY sortierung';
$ergebnis = mysql_query($abfrage);
if ($ergebnis)
{
?>
<div id="artikelliste">
<b>Kategorien<b> &nbsp;&nbsp;<a href="<?php echo $_SERVER['PHP_SELF']; ?>?action=neu">[+]</a>
<?php
    // Erster Kategorien-DIV muss etwas anders
    // formatiert sein als die folgenden => mit
    // Hilfe der Variable $erste_zeile laesst sich
    // die erste Zeile "dingfest" machen 
    $erste_zeile = 'j';
    while ($datensatz = mysql_fetch_array($ergebnis, MYSQL_ASSOC))
    {
        if ('j' == $erste_zeile)
        {
            echo '<div class="artikel"></div>';
            $erste_zeile = 'n';
        }
        $kat = htmlentities($datensatz['kat']);

        // Formular-Felder bei der zur Bearbeitung angeklickten
        // Kategorie anzeigen
        if (isset($_GET['action']) && $_GET['action'] == 'edit' && $_GET['k_id'] == $datensatz['k_id'])
        {
        ?>
         <div class="artikel" style="clear: both;margin: 2px 0px 0px 0px; padding-bottom: 4px">
         <div class="artikelinfos" style="margin-left:0px;">
        <input type="text" size="28" name="kat" value="<?php echo $kat; ?>" style="font-weight: normal" /> &nbsp;&nbsp;
    <span class="label">Sort:</span> <input type="text" size="2" name="sortierung" value="<?php echo $datensatz['sortierung']; ?>" style="font-weight: normal" /> &nbsp;&nbsp;
    <span class="label">Aktiv:</span> <input type="radio" name="aktiv" value="1" <?php if($datensatz['aktiv']==1)echo 'checked="checked"'; ?> /><span class="label">Ja</span> <input type="radio" name="aktiv" value="0" <?php if($datensatz['aktiv']==0)echo 'checked="checked"'; ?> /><span class="label">Nein</span>
    
    <input type="hidden" name="k_id" value="<?php echo $datensatz['k_id']; ?>" />
    &nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" value="Speichern" name="schicken" style="font-weight: normal" /><script language="JavaScript"><!--
    function start(){ document.editform.elements[0].select(); }
    window.onload = start;
    // -->
    </script>
        </div>
        </div>
         <?php
         }
         // alle anderen Kategorien werden normal angezeigt
         // (nicht in Formular-Feldern)
         else
         {
         ?>
            <div class="artikel" style="margin: 2px 0px 0px 0px; padding-bottom: 2px">
            <div class="artikelinfos" style="margin-left:0px;float:left;">
                <a href="<?php echo $_SERVER['PHP_SELF']; ?>?k_id=<?php echo $datensatz['k_id'].'&action=edit'; ?>"><?php echo $datensatz['sortierung'].' '.$kat; ?></a>
            </div>
            <div style="margin: 2px 0px 0px 482px; padding-bottom: 2px"><a href="<?php echo $_SERVER['PHP_SELF']; ?>?action=delete&k_id=<?php echo $datensatz['k_id']; ?>" onclick="return confirm('Wirklich lschen?')">[-]</a></div>
            </div>
        <?php
        }
        
    }
    // Falls der Links fuers Neuerfassen einer Kategorie
    // angeklickt wurde, braucht es unterhalb der bestehenden
    // Kategorien Formularfelder fuer den Neueintrag
    if (isset($_GET['action']) && $_GET['action'] == 'neu')
    {
    ?>
    <p><input type="text" size="28" name="kat" value="" style="font-weight: normal"> &nbsp;&nbsp;
    <span class="label">Sort:</span> <input type="text" size="2" name="sortierung" value="" style="font-weight: normal"> &nbsp;&nbsp;
    <span class="label">Aktiv:</span> <input type="radio" name="aktiv" value="1"><span class="label">Ja</span> <input type="radio" name="aktiv" value="0" checked="checked"><span class="label">Nein</span>
    
    <input type="hidden" name="k_id" value="-1">
    &nbsp;&nbsp;&nbsp;&nbsp;<input type="submit" value="Speichern" name="schicken" style="font-weight: normal"><script language="JavaScript"><!--
    function start(){ document.editform.elements[0].select(); }
    window.onload = start;
    // -->
    </script>
    </p>
    <?php
    }
?>
<br/><br/>
<a href="index.php">Artikel</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href="<?php echo $_SERVER['PHP_SELF']; ?>?logout=1">Logout</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href="../index.php" target="_blank">Zum Shop</a>
</div>
<?php
}
// <form> ... </form>-Konstruktion abschliessen
if (isset($_GET['action']))
{
    echo '</form>';
}
mysql_free_result($ergebnis);
mysql_close($verbindung);
?>
</body>
</html>