<?php
/**
 * ----------------------------------------------------------
 * Copyright (c) 2005  KLIK! Klein Informatik  
 *                     www.klik-info.ch rklein@klik-info.ch
 * ----------------------------------------------------------
 *
 * KLIK! Mini-Shop
 *
 * Dieses Skript darf nicht in Projekten verwendet werden, die
 * faschistisches, rassistisches, sexistisches oder 
 * fanatisch-religioeses Gedankengut propagieren.
 *
 * @author      Roger Klein
 * @copyright   Frei einsetzbar, solange obige Vorgabe erfuellt ist
 *              und alle (c) Kommentar-Zeilen im Code bleiben
 * @version     1.0 | 2005-10-12
 */
 
class AufklappMenu 
{

    // Eigenschaften:
    var $mSelectedItem;
    var $mArrNameValue = array();
    var $mSelectName;
    var $mOnChangeSubmit;
    var $mReturnHtml;

    // Methoden:
    
    /**
    * Konstruktor:
    */
    function AufklappMenu($selectedItem, $arrNameValue, $selectName = 'id',
                          $onChangeSubmit = 1) 
    {    
        $this->mSelectedItem    = $selectedItem;
        $this->mArrNameValue    = $arrNameValue;
        $this->mSelectName      = $selectName;
        $this->mOnChangeSubmit  = $onChangeSubmit;
    }
    
    /**
    * Funktion erzeugeMenu
    */
    function erzeugeMenu() 
    {
        $this->mReturnHtml  =  '';
        
        // select-Tag zusammen setzen
        $this->mReturnHtml .=  '<select name="';
        $this->mReturnHtml .=  $this->mSelectName;
        $this->mReturnHtml .=  '" size="1"';
        $this->mReturnHtml .=  $this->mOnChangeSubmit 
                                ? ' onchange="this.form.submit()">' 
                                : '>';
        $this->mReturnHtml .=  "\n";

        // Menue-Eintraege  / Options erstellen
        foreach ($this->mArrNameValue as $key => $value) 
        {
            $this->mReturnHtml  .=  '<option';
            $this->mReturnHtml  .=  ' value="'.$key.'"';
            $this->mReturnHtml  .=  $this->mSelectedItem == $key 
                                     ? ' selected="selected">' 
                                     : '>';

            $this->mReturnHtml  .=  $value;
            $this->mReturnHtml  .=  "</option>\n";
        }
        
        // Schliessenden select-Tag anhaengen
        $this->mReturnHtml    .=    "</select>\n";
        
        // den HTML-Code des fix-fertigen Menues zurueck geben
        return $this->mReturnHtml;
    }    
}
?>