<?php
/**
 * ----------------------------------------------------------
 * Copyright (c) 2005  KLIK! Klein Informatik  
 *                     www.klik-info.ch rklein@klik-info.ch
 * ----------------------------------------------------------
 *
 * KLIK! Mini-Shop
 *
 * Dieses Skript darf nicht in Projekten verwendet werden, die
 * faschistisches, rassistisches, sexistisches oder 
 * fanatisch-religioeses Gedankengut propagieren.
 *
 * @author      Roger Klein
 * @copyright   Frei einsetzbar, solange obige Vorgabe erfuellt ist
 *              und alle (c) Kommentar-Zeilen im Code bleiben
 * @version     1.0 | 2005-10-12
 */
 
require_once 'inc/warenkorb.php';
require_once 'inc/db_login.php';
require_once 'inc/form_fus.php';

session_start();

if (!isset($_SESSION['mein_koerbli']))
{
    $mein_koerbli = &new warenkorb;
}
else 
{
    $mein_koerbli = $_SESSION['mein_koerbli'];
}

if (isset($_POST['killkorb']))
{
    session_destroy();
    $mein_koerbli->entleereWarenkorb();
}

if (isset($_POST['aendern']) && $_POST['aendern'] != 0)
{
    $mein_koerbli->aendereAnzahlArtikel(filter_data($_POST['aendern']),
                                        filter_data($_POST['anzahl'])); 
}

if (isset($_GET['delete']) && $_GET['delete'] != 0)
{
    $mein_koerbli->entferneArtikel(filter_data($_GET['delete'])); 
}

$_SESSION['mein_koerbli'] = $mein_koerbli;

$kategorie_id = isset($_REQUEST['kategorie_id']) ? $_REQUEST['kategorie_id'] : 1;
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/2000/REC-xhtml1-20000126/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
<head>

<!--  KLIK! Mini-Shop, Roger Klein, Version 1.0, 2005-10-12    -->
<!--  (c) KLIK! Klein Informatik, rklein[at]klik-info[dot]ch   -->
<!--  Frei einsetzbar mit diesem Hinweistext                   -->

<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
<title>KLIK! Mini-Shop</title>
<link rel="stylesheet" href="korb.css" type="text/css" />
</head>
<body>
<div id="titel">
<h3>KLIK! Mini-Shop</h3>
</div>
<div id="aufklapp">
<form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post" name="leeren">
<a href="javascript:void(0)" onclick="document.forms['leeren'].submit();return false;">&raquo; Warenkorb entleeren</a>
<input type="hidden" value="ja" name="killkorb" /></form>
</div>
<div id="artikelliste" style="top:110px">
<?php
$i           = 0;
$preis_summe = 0;

if (count($mein_koerbli->mArrArtikel) > 0)
{
    $ids = implode(',', array_keys($mein_koerbli->mArrArtikel));
    if (substr($ids, -1) == ',')
    {
        $ids = substr($ids, 0, -1);
    }
    $ergebnis = mysql_query('SELECT a_id, artikel, preis
                             FROM '.$tbl_prefix.'artikel
                             WHERE a_id IN ('.$ids.') 
                             ORDER BY artikel');
    
    $zwi_sum = 0;
    ?>
    <div id="artikel" style="margin-bottom:10px"></div>
    <table width="500" border="0" cellspacing="0" cellpadding="0">
    <?php

    while ($datensatz = mysql_fetch_array($ergebnis, MYSQL_ASSOC))
    {
    ?>
        <form action="<?php echo $_SERVER['PHP_SELF']; ?>" method="post">
            <tr valign="middle">
                <td height="20" valign="top" colspan="5" class="fett"><?php echo $datensatz['artikel']; ?></td>
            </tr>
            <tr valign="middle">
            <td width="40">
            <input type="text" name="anzahl" value="<?php echo $mein_koerbli->mArrArtikel[$datensatz['a_id']]['anz']; ?>" style="width:30px;margin: 0 0 0 0;" />
            </td>
            <td width="180">St&uuml;ck &agrave; CHF <?php echo number_format($datensatz['preis'], 2, '.', '\''); ?></td>
            <td align="right" width="60">CHF </td>
            <td align="right" width="60"><?php echo number_format($datensatz['preis'] * $mein_koerbli->mArrArtikel[$datensatz['a_id']]['anz'], 2, '.', '\''); ?><input type="hidden" name="aendern" value="<?php echo $datensatz['a_id']; ?>" /></td>
            <td align="right" width="160"><a href="javascript:void();" onclick="document.forms[<?php echo $i+1; ?>].submit();return false;">&Auml;ndern</a>&nbsp;&nbsp;|&nbsp;&nbsp;<a href="<?php echo $_SERVER["PHP_SELF"].'?delete='.$datensatz['a_id']; ?>" onclick="return confirm('Wirklich?')">L&ouml;schen</a></td>
            </tr>
            <tr>
                <td valign="bottom" height="10" colspan="5" style="border-bottom: 1px dashed black;">&nbsp;</td>
            </tr>
             <tr>
                <td valign="bottom" height="10">&nbsp;</td>
            </tr>
            
            </form>
<?php
        $preis_summe += $datensatz['preis'] * 
          $mein_koerbli->mArrArtikel[$datensatz['a_id']]['anz'];
        $i++;
    }  // end while
}  // end if

$aktueller_inhalt = $mein_koerbli->status();
if ($aktueller_inhalt[0] != 0)
{
?>
<tr>
<td width="40" class="fett" valign="bottom" height="30">Total:</td>
<td width="180"></td>
<td align="right" width="60" class="fett" valign="bottom" height="30">CHF </td>
<td align="right" width="60" class="fett" valign="bottom" height="30"><?php echo number_format($preis_summe, 2, '.', '\''); ?></td>
<td align="right" width="160"></td>
</tr>
<?php
}
else
{
?>
<tr>
            <td colspan="5" valign="bottom" height="30" class="fett">Der Warenkorb ist leer!</td>
            </tr>
<?php
}
?>
</table>
</div>
<div id="warenkorb">
<h3>Warenkorb</h3>
<div id="warenkorbinhalt">
<?php

echo 'Anzahl Artikel: <b>' . $aktueller_inhalt[0] . '</b> | ';
echo 'Total: CHF <b>' . number_format($aktueller_inhalt[1], 2, '.', '\'')
     . '</b>';
?>
</div>
<div id="warenkorblinks">
<a href="index.php?kategorie_id=<?php echo $kategorie_id; ?>">&laquo; Zur&uuml;ck zum Shop</a><br />
<a href="kasse.php?kategorie_id=<?php echo $kategorie_id; ?>">&raquo; Zur Kasse</a>
</div>
</div>
</body>
</html>